============
Contributing
============

Contributions are welcome, and they are greatly appreciated! Every
little bit helps, and credit will always be given.

You can contribute in many ways:

Types of Contributions
----------------------

Report Bugs
~~~~~~~~~~~

Report bugs at https://todo.sr.ht/~valhalla/confusable_homoglyphs

If you are reporting a bug, please include:

* Any details about your local setup that might be helpful in troubleshooting.
* Detailed steps to reproduce the bug.

Fix Bugs
~~~~~~~~

Look through the sourcehut tickets for bugs. Anything tagged with "bug"
is open to whoever wants to implement it.

Implement Features
~~~~~~~~~~~~~~~~~~

Look through the sourcehut tickets for features. Anything tagged with
"feature" is open to whoever wants to implement it.

Write Documentation
~~~~~~~~~~~~~~~~~~~

confusable_homoglyphs could always use more documentation, whether
as part of the official confusable_homoglyphs docs, in docstrings,
or even on the web in blog posts, articles, and such.

Submit Feedback
~~~~~~~~~~~~~~~

The best way to send feedback is to file an issue at
https://todo.sr.ht/~valhalla/confusable_homoglyphs.

If you are proposing a feature:

* Explain in detail how it would work.
* Keep the scope as narrow as possible, to make it easier to implement.
* Remember that this is a volunteer-driven project, and that contributions
  are welcome :)

Get Started!
------------

Ready to contribute? Here's how to set up `confusable_homoglyphs` for
local development.

1. Clone the git repository from sourcehut::

   $ git clone https://git.sr.ht/~valhalla/confusable_homoglyphs

2. Install your local copy into a virtualenv. Assuming you have virtualenvwrapper installed, this is how you set up your fork for local development::

    $ mkvirtualenv confusable_homoglyphs
    $ cd confusable_homoglyphs/
    $ python setup.py develop

3. Create a branch for local development::

    $ git checkout -b name-of-your-bugfix-or-feature

   Now you can make your changes locally.

4. When you're done making changes, check that your changes pass flake8 and the tests, including testing other Python versions with tox::

    $ flake8 confusable_homoglyphs tests
    $ python setup.py test
    $ tox

   To get flake8 and tox, just pip install them into your virtualenv.

5. Commit your changes::

    $ git add .
    $ git commit -m "Your detailed description of your changes."

7. Send the patch to mailto:~valhalla/confusable_homoglyphs-devel@lists.sr.ht::

      $ git send-email \
        --to="mailto:~valhalla/confusable_homoglyphs-devel@lists.sr.ht" \
        HEAD^

   you can see https://git-send-email.io/ for details on how to install
   and configure git-send-email.

Pull Request Guidelines
-----------------------

Before you submit a pull request, check that it meets these guidelines:

1. The pull request should include tests.
2. If the pull request adds functionality, the docs should be updated. Put
   your new functionality into a function with a docstring, and add the
   feature to the list in README.rst.
3. The pull request should work for all supported Python versions.
